/* 
 * Beispiel fuer Verwendung der FFT-Implementierung
 */
#include <stdio.h>
#include <stdlib.h>
#include "fftn.h"

#undef REAL
#define REAL	double

static REAL *Re_data = NULL, *Im_data = NULL;
#define Real_El(x,y)	Re_data [(y)*xsize + (x)]
#define Imag_El(x,y)	Im_data [(y)*xsize + (x)]

void fill_array (int xsize, int ysize)
{
}

void print_array (const char msg[], int xsize, int ysize)
{
}

int
main (int argc, char **argv)
{
   int ret;
   int dims [2];		
   int xsize, ysize;

   /* Angegeben ist eine Beispielimplementierung, die ein Eingangssignal nimmt,
    * die entspr. Anzahl an Punkten aus der Kommandozeile liest (falls keine angegeben
    * ist, wird 50000 angenommen) und dieses Signal in den Frequenzbereich transformiert.
    * Anschlieend wird zur Erluterung des Aufrufs der inversen FFT dieses Signal in
    * den Zeitbereich rcktransformiert. */
   xsize = 50000;
   ysize = 1;

   if (argc > 1) xsize = atoi (argv[1]);

   dims [0] = xsize;	
   dims [1] = ysize;

   Re_data = (REAL *) calloc (xsize * ysize, sizeof(REAL));
   Im_data = (REAL *) calloc (xsize * ysize, sizeof(REAL));
   if (Re_data == NULL || Im_data == NULL) {
      fprintf (stderr, "Unable to allocate memory for data storage.\n");
      return 1;
   }

   printf ("Example 2D fft: filling data array [%dx%d].\n", xsize, ysize);
   fill_array (xsize, ysize);

   printf ("Starting fft...");
   fflush (stdout);

   /* 2D forward fft */
   /* ACHTUNG: die fftn-Funktion berschreibt die Argument-Arrays mit den
    * Resultatwerten! Sollen die Werte erhalten bleiben, mssen die Arrays
    * daher vorher kopiert werden. */
   ret = fftn (2, dims, Re_data, Im_data, 1, 0.0);
   if (ret) return 1;

   printf ("done.\n");	
   print_array ("Transformed data:", xsize, ysize);

   /* Beispiel fr Berechnung der inversen FFT. Der 5. Parameter mu hierzu auf 
    * -1 gesetzt werden. */
   printf ("Starting inverse fft...");
   fflush (stdout);
   ret = fftn (2, dims, Re_data, Im_data, -1, (double) xsize * (double) ysize);
   if (ret) return 1;

   print_array ("Re-transformed data:", xsize, ysize);

   printf ("done.\nFreeing dynamically allocated memory\n");
   fft_free ();

   free (Im_data);
   free (Re_data);
   return 0;
}
